#!/usr/bin/env python
import builtins
from objectname import objectname
from find_module import find_module
from load_module import load_module
from public import public


@public
def getobject(fullname):
    """todo"""
    if not fullname:
        return
    # todo: validate pkgname.modname.object.key
    names = fullname.split(".")
    module = None
    for i, _ in enumerate(names):
        name = ".".join(names[0:i + 1])
        if find_module(name):
            module = load_module(name)
            if i == len(names) - 1:
                return module
        else:
            break
    if not module:  # module not found
        # __builtins__ object ?
        if hasattr(builtins, fullname):
            return getattr(builtins, fullname)
    # module ?
    if not module:
        # raise ImportError(fullname)
        return
    if objectname(module, fullname=True).lower() == fullname.lower():
        return module
    # module.object ?
    obj = module
    for i in range(i, len(names)):
        attr = names[i]
        if hasattr(obj, attr):
            obj = getattr(obj, attr)
            if i == len(names) - 1:
                return obj
